diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenHudEditor.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenHudEditor.java
index 81f896dd7..b3132923d 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenHudEditor.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenHudEditor.java
@@ -195,13 +647,12 @@ public class ScreenHudEditor
     }
 
     private ComponentAnchor getClosestAnchor(int x, int y, HudComponent component, int mouseX, int mouseY) {
-        // Get closest anchor to mouse
         ComponentAnchor anchor = ComponentAnchor.TOP_LEFT;
         int minDistance = Integer.MAX_VALUE;
         for (ComponentAnchor componentAnchor : ComponentAnchor.values()) {
-            if (componentAnchor == ComponentAnchor.CENTER) continue; // Center anchor is not valid
-            int xAnchor = component.getAnchorX(componentAnchor);
-            int yAnchor = component.getAnchorY(componentAnchor);
+            if (componentAnchor == ComponentAnchor.CENTER) continue;
+            int xAnchor = component.getDisplayedAnchorX(componentAnchor);
+            int yAnchor = component.getDisplayedAnchorY(componentAnchor);
             int distance = (int) Math.sqrt(Math.pow(mouseX - (x + xAnchor), 2) + Math.pow(mouseY - (y + yAnchor), 2));
             if (distance < minDistance) {
                 minDistance = distance;
@@ -212,13 +663,12 @@ public class ScreenHudEditor
     }
 
     private ComponentAnchor getAnchorInRadius(int x, int y, HudComponent component, int mouseX, int mouseY, int radius) {
-        // Get closest anchor to mouse
         ComponentAnchor anchor = null;
         int minDistance = Integer.MAX_VALUE;
         for (ComponentAnchor componentAnchor : ComponentAnchor.values()) {
-            if (componentAnchor == ComponentAnchor.CENTER) continue; // Center anchor is not valid
-            int xAnchor = component.getAnchorX(componentAnchor);
-            int yAnchor = component.getAnchorY(componentAnchor);
+            if (componentAnchor == ComponentAnchor.CENTER) continue;
+            int xAnchor = component.getDisplayedAnchorX(componentAnchor);
+            int yAnchor = component.getDisplayedAnchorY(componentAnchor);
             int distance = (int) Math.sqrt(Math.pow(mouseX - (x + xAnchor), 2) + Math.pow(mouseY - (y + yAnchor), 2));
             if (distance < minDistance && distance <= radius) {
                 minDistance = distance;
@@ -229,13 +679,12 @@ public class ScreenHudEditor
     }
 
     private ComponentAnchor getScreenAnchorInRadius(int x, int y, int mouseX, int mouseY, int radius) {
-        // Get closest anchor to mouse
         ComponentAnchor anchor = null;
         int minDistance = Integer.MAX_VALUE;
         for (ComponentAnchor componentAnchor : ComponentAnchor.values()) {
-            if (componentAnchor == ComponentAnchor.CENTER) continue; // Center anchor is not valid
+            if (componentAnchor == ComponentAnchor.CENTER) continue;
             int xAnchor = (int) (componentAnchor.xPosition * this.width);
-            int yAnchor = (int) (componentAnchor.yPosition * (this.height - BOTTOM_SPACE));
+            int yAnchor = (int) (componentAnchor.yPosition * this.height);
             int distance = (int) Math.sqrt(Math.pow(mouseX - (x + xAnchor), 2) + Math.pow(mouseY - (y + yAnchor), 2));
             if (distance < minDistance && distance <= radius) {
                 minDistance = distance;
@@ -245,53 +694,6 @@ public class ScreenHudEditor
         return anchor;
     }
 
-    @Override
-    public void mouseReleased(int mx, int my, int buttonNum) {
-        if (buttonNum == 0) {
-            this.heldComponent = null;
-            this.heldAnchor = null;
-            this.snappedComponent = null;
-            this.snappedAnchor = null;
-        }
-        super.mouseReleased(mx, my, buttonNum);
-    }
-
-    @Override
-    public void render(int mx, int my, float partialTick) {
-        updateComponentsUnderMouse(mx, my);
-
-        if (this.heldComponent != null) {
-            updateHeldComponent(mx, my);
-        }
-
-        renderTexturedBackground();
-
-        drawHudComponents(mx, my);
-
-        TessellatorGeneral tessellator = GLRenderer.getTessellator();
-        GLRenderer.pushFrame();
-        GLRenderer.setShader(Shaders.COLOR);
-        GLRenderer.disableState(State.DEPTH_TEST);
-        tessellator.startDrawingQuads();
-        tessellator.setColor2i(0, 255);
-        tessellator.addVertexWithUV(0, this.height - BOTTOM_SPACE + 1, 0.0D, 0.0D, 1.0D);
-        tessellator.addVertexWithUV(this.width, this.height - BOTTOM_SPACE + 1, 0.0D, 1.0D, 1.0D);
-        tessellator.addVertexWithUV(this.width, this.height - BOTTOM_SPACE, 0.0D, 1.0D, 0.0D);
-        tessellator.addVertexWithUV(0, this.height - BOTTOM_SPACE, 0.0D, 0.0D, 0.0D);
-        tessellator.draw();
-        GLRenderer.popFrame();
-
-        // Draw all anchors for screen edges
-        if (this.heldComponent != null) {
-            for (ComponentAnchor anchor : ComponentAnchor.values()) {
-                if (anchor == ComponentAnchor.CENTER) continue; // Center anchor is not valid
-                drawAnchor(0, 0, (int) (this.width * anchor.xPosition), (int) ((this.height - BOTTOM_SPACE) * anchor.yPosition), anchor);
-            }
-        }
-
-        super.render(mx, my, partialTick);
-    }
-
     @Override
     public void renderTexturedBackground() {
         super.renderTexturedBackground();
@@ -301,8 +703,8 @@ public class ScreenHudEditor
         GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         float scale = 32F;
         tessellator.startDrawingQuads();
-        tessellator.addVertexWithUV(0.0D, this.height - BOTTOM_SPACE, 0.0D, 0.0D, (float) (this.height - BOTTOM_SPACE) / scale);
-        tessellator.addVertexWithUV(this.width, this.height - BOTTOM_SPACE, 0.0D, (float) this.width / scale, (float) (this.height - BOTTOM_SPACE) / scale);
+        tessellator.addVertexWithUV(0.0D, this.height, 0.0D, 0.0D, (float) this.height / scale);
+        tessellator.addVertexWithUV(this.width, this.height, 0.0D, (float) this.width / scale, (float) this.height / scale);
         tessellator.addVertexWithUV(this.width, 0.0D, 0.0D, (float) this.width / scale, 0);
         tessellator.addVertexWithUV(0.0D, 0.0D, 0.0D, 0.0D, 0);
         tessellator.draw();
@@ -314,47 +716,63 @@ public class ScreenHudEditor
             lastComponent = this.componentsUnderMouse.get(this.componentsUnderMouse.size() - 1);
         }
         for (HudComponent component : HudComponents.INSTANCE.getComponents()) {
-            if (component == this.heldComponent) continue;
+            if (component == this.heldComponent && this.isDragging) continue;
             if (!component.isEnabled()) continue;
             Layout layout = component.getLayout();
             GLRenderer.pushFrame();
-            component.renderPreview(this, layout, this.width, this.height - BOTTOM_SPACE);
+            component.renderPreview(this, layout, this.width, this.height);
             GLRenderer.popFrame();
-            if (this.heldComponent == null) {
-                if (!this.componentsUnderMouse.isEmpty() && component == lastComponent) {
-                    int x = layout.getComponentX(component, this.width);
-                    int y = layout.getComponentY(component, this.height - BOTTOM_SPACE);
-                    int xSize = component.getXSize();
-                    int ySize = component.getYSize();
-                    drawBox(x, y, x + xSize, y + ySize, 0xff00ff00, 1);
-                    ComponentAnchor anchor = getClosestAnchor(x, y, component, mouseX, mouseY);
-                    int xAnchor = component.getAnchorX(anchor);
-                    int yAnchor = component.getAnchorY(anchor);
-
-                    drawAnchor(x, y, xAnchor, yAnchor, anchor);
+
+            if (component == this.selectedComponent && (!this.isDragging || component != this.heldComponent)) {
+                int x = layout.getComponentX(component, this.width);
+                int y = layout.getComponentY(component, this.height);
+                int xSize = component.getDisplayedXSize();
+                int ySize = component.getDisplayedYSize();
+
+                drawBox(x, y, x + xSize, y + ySize, 0xffff0000, 1);
+
+                if (mouseX >= x && mouseX < x + xSize && mouseY >= y && mouseY < y + ySize) {
+                    ComponentAnchor closestAnchor = getClosestAnchor(x, y, component, mouseX, mouseY);
+                    int xAnchor = component.getDisplayedAnchorX(closestAnchor);
+                    int yAnchor = component.getDisplayedAnchorY(closestAnchor);
+                    drawAnchor(x, y, xAnchor, yAnchor, closestAnchor);
                 }
+
+            } else if (component == lastComponent && component != this.selectedComponent) {
+                int x = layout.getComponentX(component, this.width);
+                int y = layout.getComponentY(component, this.height);
+                int xSize = component.getDisplayedXSize();
+                int ySize = component.getDisplayedYSize();
+
+                drawBox(x, y, x + xSize, y + ySize, 0xff00ff00, 1);
+
+                ComponentAnchor anchor = getClosestAnchor(x, y, component, mouseX, mouseY);
+                int xAnchor = component.getDisplayedAnchorX(anchor);
+                int yAnchor = component.getDisplayedAnchorY(anchor);
+                drawAnchor(x, y, xAnchor, yAnchor, anchor);
             }
         }
-        if (this.heldComponent != null) {
+
+        if (this.heldComponent != null && this.isDragging) {
             Layout layout = this.heldComponent.getLayout();
             GLRenderer.pushFrame();
-            this.heldComponent.renderPreview(this, layout, this.width, this.height - BOTTOM_SPACE);
+            this.heldComponent.renderPreview(this, layout, this.width, this.height);
             GLRenderer.popFrame();
             int x = layout.getComponentX(this.heldComponent, this.width);
-            int y = layout.getComponentY(this.heldComponent, this.height - BOTTOM_SPACE);
-            int xSize = this.heldComponent.getXSize();
-            int ySize = this.heldComponent.getYSize();
-            int xAnchor = this.heldComponent.getAnchorX(this.heldAnchor);
-            int yAnchor = this.heldComponent.getAnchorY(this.heldAnchor);
+            int y = layout.getComponentY(this.heldComponent, this.height);
+            int xSize = this.heldComponent.getDisplayedXSize();
+            int ySize = this.heldComponent.getDisplayedYSize();
+            int xAnchor = this.heldComponent.getDisplayedAnchorX(this.heldAnchor);
+            int yAnchor = this.heldComponent.getDisplayedAnchorY(this.heldAnchor);
             drawBox(x, y, x + xSize, y + ySize, 0xffff0000, 1);
             drawAnchor(x, y, xAnchor, yAnchor, this.heldAnchor);
         }
         if (this.snappedComponent != null && this.snappedAnchor != null) {
             Layout layout = this.snappedComponent.getLayout();
             int x = layout.getComponentX(this.snappedComponent, this.width);
-            int y = layout.getComponentY(this.snappedComponent, this.height - BOTTOM_SPACE);
-            int xAnchor = this.snappedComponent.getAnchorX(this.snappedAnchor);
-            int yAnchor = this.snappedComponent.getAnchorY(this.snappedAnchor);
+            int y = layout.getComponentY(this.snappedComponent, this.height);
+            int xAnchor = this.snappedComponent.getDisplayedAnchorX(this.snappedAnchor);
+            int yAnchor = this.snappedComponent.getDisplayedAnchorY(this.snappedAnchor);
             drawAnchor(x, y, xAnchor, yAnchor, this.snappedAnchor);
         }
     }
@@ -409,12 +827,12 @@ public class ScreenHudEditor
             if (!component.isEnabled()) continue;
             Layout layout = component.getLayout();
             int cx = layout.getComponentX(component, this.width);
-            int cy = layout.getComponentY(component, this.height - BOTTOM_SPACE);
-            int cXSize = component.getXSize();
-            int cYSize = component.getYSize();
+            int cy = layout.getComponentY(component, this.height);
+            int cXSize = component.getDisplayedXSize();
+            int cYSize = component.getDisplayedYSize();
             if (mouseX >= cx && mouseX < cx + cXSize && mouseY >= cy && mouseY < cy + cYSize) {
                 this.componentsUnderMouse.add(component);
             }
         }
     }
-}
+}
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java
index 6f7db9151..f2dc21dbc 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenInventory.java
@@ -108,21 +108,21 @@ public class ScreenInventory extends ScreenContainerAbstract {
         this.overlayButtonsLayout.elements.clear();
 
         if (compass) {
-            this.overlayButtonsLayout.addElement(new OverlayButtonElement<>(GameSettings.OVERLAY_SHOW_COORDS));
+            this.overlayButtonsLayout.addElement(new OverlayButtonElement<>(GameSettings.COORDS_IN_OVERLAY));
             this.uvs.add(0);
-            this.overlayButtonsLayout.addElement(new OverlayButtonElement<>(GameSettings.OVERLAY_SHOW_DIRECTION));
+            this.overlayButtonsLayout.addElement(new OverlayButtonElement<>(GameSettings.DIRECTION_IN_OVERLAY));
             this.uvs.add(1);
         }
         if (clock) {
-            this.overlayButtonsLayout.addElement(new OverlayButtonElement<>(GameSettings.OVERLAY_SHOW_TIME));
+            this.overlayButtonsLayout.addElement(new OverlayButtonElement<>(GameSettings.TIME_IN_OVERLAY));
             this.uvs.add(2);
         }
         if (rotaryCalendar) {
-            this.overlayButtonsLayout.addElement(new OverlayButtonElement<>(GameSettings.OVERLAY_SHOW_SEASON));
+            this.overlayButtonsLayout.addElement(new OverlayButtonElement<>(GameSettings.SEASON_IN_OVERLAY));
             this.uvs.add(3);
-            this.overlayButtonsLayout.addElement(new OverlayButtonElement<>(GameSettings.OVERLAY_SHOW_WEATHER));
+            this.overlayButtonsLayout.addElement(new OverlayButtonElement<>(GameSettings.WEATHER_IN_OVERLAY));
             this.uvs.add(4);
-            this.overlayButtonsLayout.addElement(new OverlayButtonElement<>(GameSettings.OVERLAY_SHOW_BIOME));
+            this.overlayButtonsLayout.addElement(new OverlayButtonElement<>(GameSettings.BIOME_IN_OVERLAY));
             this.uvs.add(5);
         }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
index 72ed040fc..e315fd2c7 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
@@ -9,7 +9,6 @@ import com.mojang.logging.LogUtils;
 import net.minecraft.client.entity.player.PlayerLocalMultiplayer;
 import net.minecraft.client.gui.chat.ScreenChat;
 import net.minecraft.client.gui.Gui;
-import net.minecraft.client.gui.HeldItemTooltipElement;
 import net.minecraft.client.gui.ScreenPhotoMode;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.OpenGLHelper;
@@ -77,12 +76,10 @@ public class HudIngame extends Gui {
     protected FontRenderer fontRenderer;
     public int chatScroll = 0;
 
-    public final HeldItemTooltipElement heldItemTooltipElement;
 
     public HudIngame(Minecraft minecraft) {
         this.mc = minecraft;
         this.fontRenderer = this.mc.font;
-        this.heldItemTooltipElement = new HeldItemTooltipElement();
     }
 
     public void renderGameOverlay(float partialTicks, boolean flag, int mouseX, int mouseY) {
@@ -91,7 +88,6 @@ public class HudIngame extends Gui {
         I18n stringtranslate = I18n.getInstance();
         int width = this.mc.resolution.getScaledWidthScreenCoords();
         int height = this.mc.resolution.getScaledHeightScreenCoords();
-        int sp = (int) ((GameSettings.SCREEN_PADDING.value * height) / 8);
         this.mc.worldRenderer.setupScaledResolution();
 
         GLRenderer.enableState(State.BLEND);
@@ -117,7 +113,7 @@ public class HudIngame extends Gui {
         for (final HudComponent component : HudComponents.INSTANCE.getComponents()) {
             if (component.isVisible()) {
                 GLRenderer.pushFrame();
-                component.render(this, width - sp * 2, height - sp * 2, partialTicks);
+                component.render(this, width, height, partialTicks);
                 GLRenderer.popFrame();
             }
         }
@@ -140,7 +136,7 @@ public class HudIngame extends Gui {
 
         //Text Overlays
         if (GameSettings.IMMERSIVE_MODE.drawOverlays()) {
-            drawRecordPlayingOverlay(width, height - sp, partialTicks);
+            drawRecordPlayingOverlay(width, height, partialTicks);
 
             boolean clock = false;
             boolean compass = false;
@@ -168,7 +164,7 @@ public class HudIngame extends Gui {
             }
 
             // Show Player List
-            if (!GameSettings.SHOW_DEBUG_SCREEN.value) drawPlayerList(width, height, sp);
+            if (!GameSettings.SHOW_DEBUG_SCREEN.value) drawPlayerList(width, height);
 
             if (GameSettings.SHOW_DEBUG_SCREEN.value) {
                 GLRenderer.pushFrame();
@@ -391,7 +387,7 @@ public class HudIngame extends Gui {
         }
 
         if (GameSettings.IMMERSIVE_MODE.drawChat()) {
-            drawChat(width, height, sp);
+            drawChat(width, height);
         }
 
         // Adding this mostly to see if the stitcher and dynamic textures are working properly
@@ -460,7 +456,7 @@ public class HudIngame extends Gui {
 
     private final List<String> playerListScoreStrings = new ArrayList<>();
 
-    public void drawPlayerList(int screenWidth, int screenHeight, int screenPadding) {
+    public void drawPlayerList(int screenWidth, int screenHeight) {
         if (!this.mc.isMultiplayerWorld()) return;
         if (GameSettings.PLAYER_LIST_POSITION.value == 1) {
             GameSettings.SHOW_PLAYER_LIST.value = GameSettings.KEY_PLAYER_LIST.isPressed() && this.mc.currentScreen == null;
@@ -504,17 +500,17 @@ public class HudIngame extends Gui {
         int height = rows * lineHeight + innerPadding * (rows - 1) + 2 + outerPadding - innerPadding + 2;
 
         int listX = 0;
-        int listY = screenPadding;
+        int listY = 0;
 
         if (GameSettings.PLAYER_LIST_POSITION.value == 0) {
             listX = (screenWidth - width) / 2;
         }
         if (GameSettings.PLAYER_LIST_POSITION.value == 1) {
             listX = (screenWidth - width) / 2;
-            listY = screenHeight / 6 + screenPadding;
+            listY = screenHeight / 6;
         }
         if (GameSettings.PLAYER_LIST_POSITION.value == 2) {
-            listX = screenWidth - width - screenPadding;
+            listX = screenWidth - width;
         }
 
         drawRect(listX, listY, listX + width, listY + height, 0xA8080808);
@@ -558,7 +554,7 @@ public class HudIngame extends Gui {
         }
     }
 
-    public void drawChat(int width, int height, int sp) {
+    public void drawChat(int width, int height) {
         if (GameSettings.chatVisibility.value == ChatVisibility.NEVER_SHOW) return;
 //        if(mc.currentScreen instanceof ScreenChat && ((ScreenChat) mc.currentScreen).message.startsWith("/")) return;
         int linesToShow = 10;
@@ -605,9 +601,9 @@ public class HudIngame extends Gui {
                 final byte xPad = 2;
                 final int h = MathHelper.ceil(this.fontRenderer.heightOfConstrainedChars(message, MAX_CHAT_WIDTH));
                 y -= (h + 2);
-                drawRect(xPad + sp, y - sp - 1, xPad + MAX_CHAT_WIDTH, y + h - sp + 1, alpha / 2 << 24);
+                drawRect(xPad, y - 1, xPad + MAX_CHAT_WIDTH, y + h + 1, alpha / 2 << 24);
                 GLRenderer.enableState(State.BLEND);
-                this.fontRenderer.renderWidthConstrained(message, xPad + sp, y - sp, MAX_CHAT_WIDTH).setShadow().setColor(0xFFFFFF + (alpha << 24)).call();
+                this.fontRenderer.renderWidthConstrained(message, xPad, y, MAX_CHAT_WIDTH).setShadow().setColor(0xFFFFFF + (alpha << 24)).call();
             }
         }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponent.java b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponent.java
index 523b663e2..b21e0784a 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/component/HudComponent.java
@@ -7,10 +7,17 @@ import net.minecraft.client.gui.hud.HudIngame;
 import net.minecraft.client.gui.hud.component.layout.LayoutAbsolute;
 import net.minecraft.client.gui.hud.component.layout.Layout;
 import net.minecraft.client.gui.hud.component.layout.LayoutSnap;
+import net.minecraft.client.gui.options.components.KeyBindingComponent;
+import net.minecraft.client.gui.options.components.OptionsComponent;
+import net.minecraft.client.option.KeyBinding;
 import net.minecraft.client.option.Option;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.State;
 
+import java.util.ArrayList;
+import java.util.List;
+import java.util.function.Supplier;
+
 public abstract class HudComponent {
     protected static final Minecraft mc = Minecraft.getMinecraft();
 
@@ -18,6 +25,12 @@ public abstract class HudComponent {
     private final int xSize;
     private final int ySize;
 
+    private final List<Option<?>> rawOptions = new ArrayList<>();
+    private final List<Supplier<OptionsComponent>> optionComponentSuppliers = new ArrayList<>();
+
+    private final List<KeyBinding> rawKeyBindings = new ArrayList<>();
+    private final List<Supplier<KeyBindingComponent>> keyBindingComponentSuppliers = new ArrayList<>();
+
     Layout layout;
 
     public HudComponent(String key, int xSize, int ySize, Layout layout) {
@@ -48,30 +61,72 @@ public abstract class HudComponent {
         return key;
     }
 
-    public int getXSize() {
+    public int getDisplayedXSize() {
         if (!isEnabled() || (!(mc.currentScreen instanceof ScreenHudEditor) && !isVisible())) return 0;
         return xSize;
     }
 
-    public int getYSize() {
+    public int getDisplayedYSize() {
         if (!isEnabled() || (!(mc.currentScreen instanceof ScreenHudEditor) && !isVisible())) return 0;
         return ySize;
     }
 
-    public int getAnchorX(ComponentAnchor anchor) {
-        return (int) (anchor.xPosition * this.getXSize());
+    public int getDisplayedAnchorX(ComponentAnchor anchor) {
+        return (int) (anchor.xPosition * this.getDisplayedXSize());
+    }
+
+    public int getDisplayedAnchorY(ComponentAnchor anchor) {
+        return (int) (anchor.yPosition * this.getDisplayedYSize());
+    }
+
+    public int getTrueXSize() {
+        return xSize;
+    }
+
+    public int getTrueYSize() {
+        return ySize;
     }
 
-    public int getAnchorY(ComponentAnchor anchor) {
-        return (int) (anchor.yPosition * this.getYSize());
+    public int getTrueAnchorX(ComponentAnchor anchor) {
+        return (int) (anchor.xPosition * this.getTrueXSize());
+    }
+
+    public int getTrueAnchorY(ComponentAnchor anchor) {
+        return (int) (anchor.yPosition * this.getTrueYSize());
     }
 
     public Layout getLayout() {
         return layout;
     }
 
-    public Option<?> getAttachedOption() {
-        return null;
+    @SuppressWarnings("unchecked")
+    public <T extends HudComponent> T addAttachedOption(Option<?> option, Supplier<OptionsComponent> supplier) {
+        this.rawOptions.add(option);
+        this.optionComponentSuppliers.add(supplier);
+        return (T) this;
+    }
+
+    @SuppressWarnings("unchecked")
+    public <T extends HudComponent> T addAttachedKeyBinding(KeyBinding keyBinding, Supplier<KeyBindingComponent> supplier) {
+        this.rawKeyBindings.add(keyBinding);
+        this.keyBindingComponentSuppliers.add(supplier);
+        return (T) this;
+    }
+
+    public List<Supplier<OptionsComponent>> getOptionSuppliers() {
+        return this.optionComponentSuppliers;
+    }
+
+    public List<Supplier<KeyBindingComponent>> getKeyBindingSuppliers() {
+        return this.keyBindingComponentSuppliers;
+    }
+
+    public List<Option<?>> getRawOptions() {
+        return this.rawOptions;
+    }
+
+    public List<KeyBinding> getRawKeyBindings() {
+        return this.rawKeyBindings;
     }
 
     public abstract void render(HudIngame hud, int xSizeScreen, int ySizeScreen, float partialTick);
